//       SoundTrack game engine demo by Sam Turner
//	 NCCA Innovations Project 2006
// 	 All code Copyright


#include "fmod.h"    //fmod music library functions
#include <dirent.h>  //for accessing the files


FSOUND_STREAM *musicStream, *musicStream2;	//two sound streams
int x, y;
int channelPlaying = 0;				//flag to set which music channel is currently playing
float getVolumeRatio = 0.0;		
float AvVol = 0.5;				//average volume
float waveMul = 1.0;				//wave height multiplier


initMusic()
{
FSOUND_Init(44100, 32, 0);		//initialise

DIR *directory;
struct dirent *dirStruct;
char track1[255], track2[255];		//filenames

directory = opendir("./mp3s");		//enter mp3 directory
dirStruct = readdir(directory);		//read first item


//discard any '..' or '.' file entries
if (!strcmp(dirStruct->d_name, "..")||!strcmp(dirStruct->d_name, ".")) 

{dirStruct = readdir(directory);}

if (!strcmp(dirStruct->d_name, "..")||!strcmp(dirStruct->d_name, "."))

{dirStruct = readdir(directory);}

strcpy(track1, "./mp3s/");
strcat(track1, dirStruct->d_name);	//get filename
printf("%s", track1);			//print filename for debugging
musicStream =  FSOUND_Stream_Open(track1,0, 0, 0);	//load file


//load second file
dirStruct = readdir(directory);

if (!strcmp(dirStruct->d_name, "..")||!strcmp(dirStruct->d_name, "."))

{dirStruct = readdir(directory);}

if (!strcmp(dirStruct->d_name, "..")||!strcmp(dirStruct->d_name, "."))

{dirStruct = readdir(directory);}

strcpy(track2, "./mp3s/");
strcat(track2, dirStruct->d_name);
printf("%s", track2);
musicStream2 =  FSOUND_Stream_Open(track2,0, 0, 0);

//play both files
x = FSOUND_Stream_Play(0,musicStream);

y = FSOUND_Stream_Play(1,musicStream2);

//set the volume of channel 1 to 0
FSOUND_SetVolume(1,0);

//initialse effects module
FSOUND_DSP_SetActive(FSOUND_DSP_GetFFTUnit(),1);


}

getLevels(float *levels)
{
        int i;
        float spectrum[512];        
        memcpy(spectrum, FSOUND_DSP_GetSpectrum(), 512);  //copy spectrum data to array
        
         //extract elements and multiply by wave height multiplier
        for (i=0; i<64; i++)
        {
            levels[i] = spectrum[(i)*2]*waveMul; 
        }
        
	//mirrored
        for (i=0; i<64; i++)
        {
            levels[127-i] = spectrum[(i)*2]*waveMul;   
        }
                
}

float getVolume()
{      
      float *spectrum;   
      float total = 0.0, average;
      int i;
            
      spectrum = FSOUND_DSP_GetSpectrum(); 
      
      //get a sample of spectrum levels and find the average for a rough volume level 
      for (i=10; i<=200; i+=10)
      {
          total+= spectrum[i]*waveMul;  
          
      }
      
      average = total/20.0;      
      return average;
}

changeMusicFreq(float freq)
{
FSOUND_SetFrequency(channelPlaying,(int)(freq));   //change music frequency (speed)                   
}


//sets the ratio of volume between one channel and the other

setVolumeRatio(float volume)
{
            if (volume<0.05) volume = 0.0;  //prune volume level
            if (volume>0.95) volume = 1.0;
            getVolumeRatio = volume;
            FSOUND_SetVolume((channelPlaying+1)%2,volume*255);
            FSOUND_SetVolume(channelPlaying,255-(volume*255));  
            
              
}


